unit hauptu;

{
procedure GeneriereTextBlaBlubb(EinPaarParameter wie _Font oder _Char)
var
  bmp:Graphics.TBitmap;
  r, g, b: Byte;
begin
try
// Bentigte Breite und Hhe fr die Textur errechnen
FFontHeight := Font_TextHeight(_Font, _Char);
FFontWidth := Font_TextWidth(_Font, _Char);
// Die Textur MUSS Schwarz/Weiss sein, die Schrift kann dann spter mit glColor eingefrbt werden. 
// Textur auf ein Bitmap zeichnen
bmp := Graphics.TBitmap.Create;
bmp.PixelFormat := pf32bit;
bmp.Canvas.Font.Assign(_Font); // Schrift anpassen
bmp.Canvas.Font.Color := clWhite;
bmp.Width := Power_Of_2(FFontWidth);
bmp.Height := Power_Of_2(FFontHeight);
bmp.Canvas.Brush.Color := clBlack;
bmp.Canvas.FillRect(Rect(0,0,bmp.width,bmp.height));
bmp.Canvas.TextOut(0, 0, _Char); // Text auf dem Bitmap ausgeben
FintBreiteDesBildes := bmp.Width;
FintHoeheDesBildes := bmp.Height;
FTextur.Bind;
FTextur.AssignFromBitmap(bmp); // vom Bitmap auf die Textur bertragen
fTextur.ConvertTo(ifLuminance);
fTextur.InternalFormat := ifAlpha;
FTextur.GenTexture; // an OpenGL bergeben
finally
FreeAndNil(bmp);
end;
end;

//einbinden
TColor2RGB(FFont.Color, r, g, b);
glColor3ub(r, g, b);
FTextur.Bind;

}


interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, FileCtrl, ImgList, Grids, SortGrid,
  DGLOpenGL,easySDL,SDL,SDL_Image;

const
  _cap='OGL_HENRYs V1.0 by Daniel Schwamm';

  _brennweite=70.0;
  _NearClipping=1;   //sehe ab x m
  _FarClipping=1000;  //sehe bis x m


  _spanok=true;//false;

  _bremse=00;
  _pstep=1;    //laufschrittweite
  _rstep=5;    //rotationsgrad


  _startmap='Info';
  _box=3;            //0 nicht, 1=nur boden, 2=nur decke, 3=alles
  _lightok=false;    //seitenlicht an/aus
  _panelok=true;     //minmap an/aus
  _fogok=false;      //nebel an/aus
  _infocap=false;

  _txamax=200;  //max. anzahl an texturen je map (inkl. personen)

  _piover180=pi/180;

type
  tpos=record
    x,y,z:single;
  end;
  tdim=record
    w,h,d:single;
  end;
  trot=record
    x,y,z:smallint;
  end;
  ttex=record
    wc,dc:byte;
    o,u,l,r,v,h:byte;
  end;

  tquad=record
    pos:tpos;
    dim:tdim;
    tex:ttex;
  end;

  tout=record
    ch:char;
    map:string;
    mapstart:string;
  end;

  tqa=array of tquad;

  tmap=record
    name:string;  //name der map, z.B. "info"
    anz:word;     //anzahl tquads
    quads:tqa;    //folge von tquads
    fn:string;    //dateiname

    txdecke:byte;      //id der decken-textur
    txdeckewc:single;  //decken-kachelung breite
    txdeckedc:single;  //decken-kachelung tiefe
                       //keine Hhen-Kachelung, denn die Hhe der Decke ist Null

    // "zwischendecke" (nur fr "Flur")
    txdeckez:byte;
    txdeckezwc:single;
    txdeckezdc:single;

    txboden:byte;      //id boden-textur
    txbodenwc:single;  //boden-kacheln breite
    txbodendc:single;  //boden-kacheln tiefe

    startpos:tpos;     //homeposition des betrachters
    startrot:trot;     //homerotation des betrachters

    w,d,h:single;      //breite, tiefe und hhe der Map

    outa:array[0..5]of tout;       //definierte ausgnge
    durchgang:array[0..5]of char;  //definierte durchgnge
  end;


  Thauptf = class(TForm)
    mapm: TMemo;
    flb: TFileListBox;
    pflb: TFileListBox;
    txalb: TListBox;
    p: TPanel;
    helpm: TMemo;
    procedure FormCreate(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
    homedir:string;
    dc:HDC;
    rc:HGLRC;

    pbmp,ppbmp:tbitmap;

    map:tmap;

    boxmode:byte;

    ccolor:tcolor;

    walkbias,walkbiasangle,
    lookupdown,
    px,py,pz,
    ppx,ppy,ppz,
    rotx,roty,rotz:double;

    lastpos:tpos;
    lightok:bool;
    fogok:bool;

    txa:array[0.._txamax]of gluint;

    procedure init;
    procedure SetupGL;
    procedure IdleHandler(Sender: TObject; var Done: Boolean);
    procedure ErrorHandler;
    procedure DrawScene;
    procedure sethome;
    function ftos(d:double):string;
    function angel(d:double):double;

    procedure drawquad(q:tquad);
    procedure texturesfree;

    procedure coltex(tx:byte);
    procedure showtxa;
    procedure filllighta(var a:array of single;d0,d1,d2,d3:single);
  end;

var
  hauptf: Thauptf;

implementation

uses mapu,panelu;

{$R *.dfm}

procedure Thauptf.init;

  procedure settx(fn:string;r:integer);
  var
    tex:PSDL_Surface;
    //tx:gluint;
  begin
    tex:=IMG_Load(pchar(fn));
    if assigned(tex) then begin
      //glGenTextures(1,@tx);
      glGenTextures(1,@txa[r]);
      glBindTexture(GL_TEXTURE_2D,txa[r]);

      glEnable(GL_TEXTURE_2D);

      glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
      glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
      glTexParameteri(gl_texture_2d,GL_GENERATE_MIPMAP_SGIS,GL_TRUE);

      // Achtung! Einige Bildformate erwarten statt GL_RGB, GL_BGR.
      //Diese Konstante fehlt in den Standard-Headern
      glTexImage2D(GL_TEXTURE_2D,0,3,tex^.w,tex^.h,0,GL_RGB,GL_UNSIGNED_BYTE,tex^.pixels);
      SDL_FreeSurface(tex);
    end;
  end;

var
  r:integer;
begin
  for r:=0 to _txamax-1 do begin
    txa[r]:=0;
  end;

  //personen texturen als erstes
  pflb.Directory:=homedir+'\personen';
  for r:=0 to pflb.items.count-1 do begin
    settx(pflb.Directory+'\'+pflb.Items[r],r);
  end;

  if      _startmap='Info' then mapu.setmap_info
  else if _startmap='Flur' then mapu.setmap_flur
  else if _startmap='Mode' then mapu.setmap_mode
  else if _startmap='EDV' then mapu.setmap_edv;

  boxmode:=_box;
  p.visible:=_panelok;

  FormResize(Self);
  sethome;
end;

procedure Thauptf.FormCreate(Sender: TObject);
begin
  homedir:=extractfilepath(application.exename);
  caption:=_cap;

  pbmp:=tbitmap.Create;
  ppbmp:=tbitmap.Create;

  DC:=GetDC(Handle);
  if not InitOpenGL then Application.Terminate;
  RC:=CreateRenderingContext(
    DC,
    [opDoubleBuffered],
    32,     //farbbits
    24,
    0,0,0,
    0
  );
  ActivateRenderingContext(DC,RC);

  lightok:=_lightok;

  setupgl;

  ccolor:=clred;

  init;
  Application.OnIdle:=IdleHandler;

  width:=640;
  height:=480;

  helpm.Height:=360;
end;

procedure thauptf.filllighta(var a:array of single;d0,d1,d2,d3:single);
begin
  a[0]:=d0;a[1]:=d1;a[2]:=d2;a[3]:=d3;
end;

procedure Thauptf.SetupGL;
var
  light0_ambient,
  light0_diffuse,
  light0_pos,
  lmodel_ambient,
  mat_shininess,
  mat_specular:array[0..3] of single;
  fogCol:array[0..3]of single;
begin
  //glDepthrange(1,mapz*100);
  glDepthFunc(gl_less);
  //Tiefentest aktivieren

  glenable(GL_ALPHA_TEST);
  glShadeModel(GL_SMOOTH);
  glEnable(GL_BLEND );
  glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);

  glDepthMask(TRUE);
  glDepthFunc(GL_LESS );
  glenable(GL_DEPTH_TEST);

  //lichtwerte
  //filllighta(light0_ambient,2.0,2.0,2.0,1.0); //hintergrundlicht
  filllighta(light0_ambient,0.5,0.5,0.5,1.0); //hintergrundlicht
  filllighta(light0_diffuse,1,1,1,1.0);       //gerichtetet licht
  filllighta(light0_pos,0,0,2,1.0);
  filllighta(lmodel_ambient,1.0,1.0,1.0,1.0);
  filllighta(mat_specular,1,1,1,1);       //reflektionslicht
  filllighta(mat_shininess,90.0,0,0,0);       //0=harter bergang bis 128

  // Lichtquelle 0 einstellen: links fenster
  glLightfv(GL_LIGHT0,GL_AMBIENT,@light0_ambient);
  glLightfv(GL_LIGHT0,GL_DIFFUSE,@light0_diffuse);
  glLightfv(GL_LIGHT0,GL_POSITION,@light0_pos);
  //glLightfv(GL_LIGHT0,GL_SPOT_DIRECTION,@light0_pos);



  // Beleuchtungsmodell waehlen
  glLightModelfv(GL_LIGHT_MODEL_AMBIENT,@lmodel_ambient);
  //glLightModeli(GL_LIGHT_MODEL_TWO_SIDE,GL_FALSE);
  glLightModeli(GL_LIGHT_MODEL_LOCAL_VIEWER,GL_FALSE);

  // Materialeigenschaften definieren
  glMaterialfv(GL_FRONT_AND_BACK,GL_SHININESS,@mat_shininess);
  glMaterialfv(GL_FRONT_AND_BACK,GL_SPECULAR,@mat_specular);

  // ...und Beleuchtung einschalten.
  if lightok then begin
    glEnable(GL_LIGHTING);
    glEnable(GL_LIGHT0);
  end;

  //nebel
  //GL_EXP, GL_EXP2, GL_LINEAR
  glFogi(GL_FOG_MODE,GL_LINEAR);
  fogcol[0]:=0.5;fogcol[1]:=0.5;fogcol[2]:=0.5;
  glFogfv(GL_FOG_COLOR,@fogCol); // farbe
  glFogf(GL_FOG_DENSITY,0.35); // dichter je grsser
  //gl_dont_care, gl_nicest, gl_fastest
  glHint(GL_FOG_HINT,GL_DONT_CARE); // Fog Hint Value
  glFogf(GL_FOG_START,5.0); // start nebel
  glFogf(GL_FOG_END,10.0); // ende nebel
  if fogok then glEnable(GL_FOG);

  glenable(GL_TEXTURE_MATRIX);
end;

procedure Thauptf.FormResize(Sender: TObject);
begin
  helpm.left:=(width-helpm.width) div 2;
  helpm.top:=(height-helpm.height) div 2;

  glViewport(0,0,ClientWidth,ClientHeight);

  glMatrixMode(GL_PROJECTION);
  glLoadIdentity;
  gluPerspective(_brennweite,1.5,_NearClipping,_FarClipping);

  glMatrixMode(GL_MODELVIEW);
  DrawScene;
end;

procedure Thauptf.texturesfree;
var
  r,rr:integer;
begin
  for r:=flb.items.count-1 downto 0 do begin
    rr:=r+pflb.Items.count;
    if txa[rr]<>0 then glDeleteTextures(1,@txa[rr]);
    txa[rr]:=0;
  end;
end;

procedure Thauptf.FormDestroy(Sender: TObject);
var
  r:integer;
begin
  DeactivateRenderingContext;
  DestroyRenderingContext(RC);
  texturesfree;

  //personen lschen
  for r:=pflb.items.count-1 downto 0 do begin
    if txa[r]<>0 then glDeleteTextures(1,@txa[r]);
    txa[r]:=0;
  end;

  ReleaseDC(Handle,DC);

  ppbmp.Free;
  pbmp.Free;
end;

procedure Thauptf.IdleHandler(Sender: TObject; var Done: Boolean);
begin
  drawscene;
  if _bremse>0 then sleep(_bremse);
  done:=false;
end;

procedure Thauptf.ErrorHandler;
begin
  Caption:=gluErrorString(glGetError);
  if caption<>'no error' then
    beep;
end;

function thauptf.ftos(d:double):string;
begin
  result:=format('%.2f',[d]);
end;

function thauptf.angel(d:double):double;
begin
  if d>360 then d:=d-360;
  if d<0 then d:=360+d;
  result:=d;
end;

procedure thauptf.coltex(tx:byte);
begin
  glBindTexture(GL_TEXTURE_2D,txa[tx]);
  glEnable(GL_TEXTURE_2D);
end;

procedure Thauptf.DrawScene;
var
  //dw,dz,
  x,y,z,r:integer;
  dd,w,h,d:single;
  scenerotz,sceneroty,xtrans,ytrans,ztrans:double;
  collision:bool;
  {
  light0_ambient,
  light0_diffuse,
  light0_pos,
  lmodel_ambient,
  mat_shininess,
  mat_specular:array[0..3] of single;
  }
  //light0_pos:array[0..3] of single;
begin

  //collisionscheck
  panelu.paintp(collision);
  if collision then begin
    px:=lastpos.x;
    py:=lastpos.y;
    pz:=lastpos.z;
  end;

  //hintergrundfarbe
  if fogok then glClearColor(0.5,0.5,0.5,1)
           else glClearColor(0.0,0.0,0.0,1);

  //bildpuffer komplett lschen
  glClear(GL_COLOR_BUFFER_BIT OR GL_DEPTH_BUFFER_BIT);

  glLoadIdentity;

  //filllighta(light0_pos,px,py,pz,1.0);


  xtrans:=-px;
  ytrans:=-py-walkbias;
  ztrans:=-pz;
  lookupdown:=360.0-rotx;
  sceneroty:=360.0-roty;
  scenerotz:=360.0-rotz;

  glRotatef(lookupdown,1.0,0,0);
  glRotatef(sceneroty,0,1.0,0);
  glRotatef(scenerotz,0,0,1.0);
  glTranslatef(xtrans,ytrans,ztrans);

  if _infocap then begin
    caption:=
      ftos(px)+'/'+ftos(py)+'/'+ftos(pz)+
      ' | '+
      ftos(rotx)+'/'+ftos(roty)+'/'+ftos(rotz)+
      ' | '+
      'Objekte: '+inttostr(map.anz);
  end;

  //room
  x:=0;y:=0;z:=0;
  w:=map.w/2;h:=hauptf.map.h;d:=map.d/2;

  //boxmode: 0 nicht, 1=nur boden, 2=nur decke, 3=alles
  if(boxmode=3)or(boxmode=2)then begin
    //decke
    //glBindTexture(GL_TEXTURE_2D,map.txdecke);glEnable(GL_TEXTURE_2D);
    coltex(map.txdecke);
    glBegin(GL_QUADS);
      glTexCoord2f(0,0);glVertex3d(x+0,y+h,z+0);
      glTexCoord2f(0,map.txdeckedc);glVertex3d(x+0,y+h,z+d);
      glTexCoord2f(map.txdeckewc,map.txdeckedc);glVertex3d(x+w,y+h,z+d);
      glTexCoord2f(map.txdeckewc,0);glVertex3d(x+w,y+h,z+0);
    glEnd();
  end;

  if(boxmode=3)or(boxmode=1)then begin
    //boden
    h:=0;
    //glBindTexture(GL_TEXTURE_2D,map.txboden);glEnable(GL_TEXTURE_2D);
    coltex(map.txboden);
    glBegin(GL_QUADS);
      glTexCoord2f(0,0);glVertex3d(x+0,y+h,z+0);
      glTexCoord2f(0,map.txbodendc);glVertex3d(x+0,y+h,z+d);
      glTexCoord2f(map.txbodenwc,map.txbodendc);glVertex3d(x+w,y+h,z+d);
      glTexCoord2f(map.txbodenwc,0);glVertex3d(x+w,y+h,z+0);
    glEnd();
  end;


  if map.name='Flur' then begin
    //zwischendecke
    coltex(map.txdeckez);

    //lngsbalken
    dd:=1;
    for z:=0 to 2 do begin
      dd:=dd+2;
      glBegin(GL_QUADS);
        glTexCoord2f(0,0);glVertex3d(x+0,5.2,dd+0);
        glTexCoord2f(0,1);glVertex3d(x+0,5.2,dd+0.5);
        glTexCoord2f(w,1);glVertex3d(x+w,5.2,dd+0.5);
        glTexCoord2f(w,0);glVertex3d(x+w,5.2,dd+0);
      glEnd();
    end;

    //querbalken
    dd:=0;
    for x:=0 to ((trunc(w)-1)div 5)-1 do begin
      dd:=dd+5;
      glBegin(GL_QUADS);
        glTexCoord2f(0,0);glVertex3d(dd,5.3,0);
        glTexCoord2f(0,1);glVertex3d(dd,5.3,d);
        glTexCoord2f(1,1);glVertex3d(dd+0.5,5.3,d);
        glTexCoord2f(1,0);glVertex3d(dd+0.5,5.3,0);
      glEnd();
    end;

  end;


  for r:=0 to map.anz-1 do begin
    drawquad(map.quads[r]);
  end;


  SwapBuffers(DC);

end;

procedure thauptf.sethome;
begin
  px:=map.startpos.x;
  py:=map.startpos.y;
  pz:=map.startpos.z;

  rotx:=map.startrot.x;
  roty:=map.startrot.y;
  rotz:=map.startrot.z;
end;

procedure Thauptf.drawquad(q:tquad);
var
  x,y,z,w,h,d:single;
begin
  x:=q.pos.x;y:=q.pos.y;z:=q.pos.z;
  w:=q.dim.w;h:=q.dim.h;d:=q.dim.d;

  x:=x/2;y:=y;z:=z/2;
  w:=w/2;h:=h;d:=d/2;


  //q.tex.dc:=q.tex.wc;
  if h<hauptf.map.h then begin
    //oben
    coltex(q.tex.o);
    glBegin(GL_QUADS);
      glTexCoord2f(0,0);glVertex3d(x+0,y+h,z+0);
      glTexCoord2f(0,-q.tex.dc);glVertex3d(x+0,y+h,z+d);
      glTexCoord2f(-q.tex.wc,-q.tex.dc);glVertex3d(x+w,y+h,z+d);
      glTexCoord2f(-q.tex.wc,0);glVertex3d(x+w,y+h,z+0);
    glEnd();
  end;

  //links
  coltex(q.tex.l);
  glBegin(GL_QUADS);
    glTexCoord2f(0,0);glVertex3d(x+0,y+0,z+0);
    glTexCoord2f(0,-q.tex.dc);glVertex3d(x+0,y+h,z+0);
    glTexCoord2f(-q.tex.wc,-q.tex.dc);glVertex3d(x+0,y+h,z+d);
    glTexCoord2f(-q.tex.wc,0);glVertex3d(x+0,y+0,z+d);
  glEnd();

  //rechts
  coltex(q.tex.r);
  glBegin(GL_QUADS);
    glTexCoord2f(0,0);glVertex3d(x+w,y+0,z+0);
    glTexCoord2f(0,-q.tex.dc);glVertex3d(x+w,y+h,z+0);
    glTexCoord2f(-q.tex.wc,-q.tex.dc);glVertex3d(x+w,y+h,z+d);
    glTexCoord2f(-q.tex.wc,0);glVertex3d(x+w,y+0,z+d);
  glEnd();

  //vorne
  coltex(q.tex.v);
  glBegin(GL_QUADS);
    glTexCoord2f(0,0);glVertex3d(x+0,y+0,z+d);
    glTexCoord2f(0,-q.tex.dc);glVertex3d(x+0,y+h,z+d);
    glTexCoord2f(-q.tex.wc,-q.tex.dc);glVertex3d(x+w,y+h,z+d);
    glTexCoord2f(-q.tex.wc,0);glVertex3d(x+w,y+0,z+d);
  glEnd();

  //hinten
  coltex(q.tex.h);
  glBegin(GL_QUADS);
    glTexCoord2f(0,0);glVertex3d(x+0,y+0,z+0);
    glTexCoord2f(0,-q.tex.dc);glVertex3d(x+0,y+h,z+0);
    glTexCoord2f(-q.tex.wc,-q.tex.dc);glVertex3d(x+w,y+h,z+0);
    glTexCoord2f(-q.tex.wc,0);glVertex3d(x+w,y+0,z+0);
  glEnd();

end;

procedure Thauptf.FormKeyDown(Sender: TObject; var Key: Word;Shift: TShiftState);
begin
  lastpos.x:=px;
  lastpos.y:=py;
  lastpos.z:=pz;

  if ssctrl in shift then begin
    if key=vk_up then rotx:=rotx-_rstep
    else if key=vk_down then rotx:=rotx+_rstep;

    if key=vk_left then rotz:=rotz-_rstep
    else if key=vk_right then rotz:=rotz+_rstep;

    exit;
  end;

  if key=vk_right then roty:=roty-_rstep
  else if key=vk_left then roty:=roty+_rstep

  else if key=vk_prior then py:=py+_pstep/2
  else if key=vk_next then py:=py-_pstep/2

  else if key=vk_up then begin
    px:=px-sin(roty*_piover180)*_pstep;
    pz:=pz-cos(roty*_piover180)*_pstep;
    if walkbiasangle>=359.0 then walkbiasangle:=0.0
                            else walkbiasangle:=walkbiasangle+90;
    walkbias:=sin(walkbiasangle*_piover180)/20.0;
  end
  else if key=vk_down then begin
    px:=px+sin(roty*_piover180)*_pstep;
    pz:=pz+cos(roty*_piover180)*_pstep;
    if walkbiasangle<=1.0 then walkbiasangle:=359.0
                          else walkbiasangle:=walkbiasangle-90;
    walkbias:=sin(walkbiasangle*_piover180)/20.0;
  end

  else if key=ord('L') then begin
    if lightok then begin
      gldisable(GL_LIGHT0);
      gldisable(GL_LIGHTING);
      lightok:=false;
    end
    else begin
      glEnable(GL_LIGHTING);
      glEnable(GL_LIGHT0);
      lightok:=true;
    end;
  end



  else if key=ord('B') then begin
    inc(boxmode);if boxmode>3 then boxmode:=0;
  end

  else if key=vk_space then sethome

  else if key=ord('H') then helpm.visible:=not helpm.visible
  else if key=ord('P') then p.visible:=not p.visible

  else if key=ord('N') then begin
    if fogok then begin
      gldisable(GL_FOG);
      fogok:=false;
    end
    else begin
      glEnable(GL_FOG);
      fogok:=true;
    end;
  end

  else if key=ord('1') then mapu.setmap_info
  else if key=ord('2') then mapu.setmap_flur
  else if key=ord('3') then mapu.setmap_mode
  else if key=ord('4') then mapu.setmap_edv

  else if key=vk_escape then close;
end;

procedure thauptf.showtxa;
var
  r:integer;
begin
  txalb.clear;
  for r:=0 to _txamax-1 do begin
    txalb.Items.add(inttostr(txa[r]));
  end;
end;

end.

