unit mapu;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs,DGLOpenGL, StdCtrls,easySDL,SDL,SDL_Image,hauptu;

//function tex(fn:string):gluInt;
procedure rdmap(fn:string;var map:tmap);

procedure setmap_info;
procedure setmap_flur;
procedure setmap_mode;
procedure setmap_edv;
function s2quad(ss:string;x,z,w,d:byte;var q:tquad):bool;

implementation

uses panelu;

{
function tex(fn:string):gluInt;
begin
  result:=hauptf.txa[hauptf.flb.Items.IndexOf(fn+'.jpg')+hauptf.pflb.Items.count];
end;
}

procedure rdmap(fn:string;var map:tmap);

  procedure settx(fn:string;r:integer);
  var
    tex:PSDL_Surface;
  begin
    tex:=IMG_Load(pchar(fn));
    if assigned(tex) then begin
      glGenTextures(1,@hauptf.txa[r]);
      glBindTexture(GL_TEXTURE_2D,hauptf.txa[r]);

      glEnable(GL_TEXTURE_2D);

      glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
      glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
      glTexParameteri(gl_texture_2d,GL_GENERATE_MIPMAP_SGIS,GL_TRUE);

      // Achtung! Einige Bildformate erwarten statt GL_RGB, GL_BGR.
      //Diese Konstante fehlt in den Standard-Headern
      glTexImage2D(GL_TEXTURE_2D,0,3,tex^.w,tex^.h,0,GL_RGB,GL_UNSIGNED_BYTE,tex^.pixels);
      SDL_FreeSurface(tex);
    end;
  end;

  procedure getdim(ch:char;x,z:byte;var w,d:byte);
  var
    s:string;
    r,c:integer;
    fullok:bool;
  begin
    //startpunkt immer, daher lschen
    s:=hauptf.mapm.lines[z];
    s[x]:='<';hauptf.mapm.lines[z]:=s;

    //wie breit ist objekt?
    w:=1;
    c:=x+1;
    while(c<length(s))and(s[c]=ch) do begin
      //markier breiteblcke
      s[c]:='_';hauptf.mapm.lines[z]:=s;
      inc(w);
      inc(c);
    end;

    //wie tief ist objekt
    d:=1;
    fullok:=_spanok;
    //fullok:=false;
    for r:=z+1 to hauptf.mapm.lines.count-1 do begin
      s:=hauptf.mapm.lines[r];
      if length(s)<x then break;
      if s[x]<>ch then break;

      //markiere tiefe-blcke
      s[x]:='|';hauptf.mapm.lines[r]:=s;

      if _spanok then begin
        //volle breite mit objekt-blcken?
        if fullok then begin
          c:=x+1;
          while(c<x+w)and(s[c]=ch) do begin
            //markiere breiteblcke
            s[c]:='>';hauptf.mapm.lines[r]:=s;
            inc(c);
          end;

          if c<x+w then fullok:=false;
        end;
      end;

      inc(d);
    end;

    //einzelblock?
    if(w=1)and(d=1)then exit;

    //raum nicht voll aufgespannt?
    if not fullok then begin
      //setze full-blcke zurck
      s:=hauptf.mapm.text;
      s:=stringreplace(s,'>',ch,[rfreplaceall]);

      if w>=d then begin
        d:=1;
        s:=stringreplace(s,'_',' ',[rfreplaceall]);
        s:=stringreplace(s,'|',ch,[rfreplaceall]);
      end
      else begin
        w:=1;
        s:=stringreplace(s,'_',ch,[rfreplaceall]);
        s:=stringreplace(s,'|',' ',[rfreplaceall]);
      end;
      hauptf.mapm.text:=s;
    end
    else begin
      s:=hauptf.mapm.text;
      s:=stringreplace(s,'>',' ',[rfreplaceall]);
      s:=stringreplace(s,'_',' ',[rfreplaceall]);
      s:=stringreplace(s,'|',' ',[rfreplaceall]);
      hauptf.mapm.text:=s;
    end;
  end;

var
  r,c:word;
  s,ss,bufs:string;
  anz:word;
  w,d:byte;
begin
  hauptf.map.name:=fn;

  //alte texturen lschen (ausser personen)
  hauptf.texturesfree;

  //texturen laden
  hauptf.flb.Directory:=hauptf.homedir+fn;
  for r:=0 to hauptf.flb.items.count-1 do begin
    settx(
      hauptf.flb.Directory+'\'+hauptf.flb.Items[r],
      r+hauptf.pflb.Items.count
    );
  end;

  //map-standard-texturen
  hauptf.map.txdecke:=hauptf.flb.Items.indexof('txdecke.jpg')+hauptf.pflb.Items.count;
  hauptf.map.txboden:=hauptf.flb.Items.indexof('txboden.jpg')+hauptf.pflb.Items.count;

  //lade map in memo
  hauptf.mapm.lines.loadfromfile(hauptf.homedir+fn+'/_map.txt');

  //map retten
  bufs:=hauptf.mapm.Text;

  //zhle objekte-blcke
  s:=trim(hauptf.mapm.Text);
  anz:=0;
  for c:=1 to length(s) do begin
    if(s[c]=' ')or(s[c]=#10)or(s[c]=#13)then continue;
    inc(anz);
  end;

  //map lschen und erstmal ber-dimenesionieren
  setlength(map.quads,0);
  setlength(map.quads,anz);
  map.anz:=anz;
  hauptf.map.w:=0;
  hauptf.map.d:=0;

   //hole objekte+personen
  anz:=0;
  for r:=0 to hauptf.mapm.lines.count-1 do begin
    s:=hauptf.mapm.lines[r];
    if length(s)>hauptf.map.w then hauptf.map.w:=length(s);
    for c:=1 to length(s) do begin
      if s[c]=' ' then continue;
      if s[c]='<' then continue;

      //person?
      if s[c] in ['0'..'9'] then begin
        ss:=s[c]+s[c+1];
        s[c]:='<';s[c+1]:=' ';
        hauptf.mapm.lines[r]:=s;
        w:=1;
        d:=1;
      end
      else begin

        //neues objekt: bestimme dimension
        getdim(s[c],c,r,w,d);

        ss:=s[c];
      end;

      //binde textur und hhe an objekt
      if s2quad(ss,c-1,r,w,d,map.quads[anz]) then begin

        //erhhe objektcounter
        inc(anz);
      end;
      

      s:=hauptf.mapm.lines[r];

    end;
    hauptf.mapm.lines[r]:=s;
  end;

  //korrigiere anzahl objekte
  map.anz:=anz;//map.anz-anzc;

  hauptf.map.d:=hauptf.mapm.lines.count;

  //decke und boden textur-aufteilung
  map.txdeckewc:=hauptf.map.w;
  map.txdeckedc:=hauptf.map.d;

  map.txbodenwc:=hauptf.map.w;
  map.txbodendc:=hauptf.map.d;

  //hauptf.showtxa;

  //map zurcksetzen
  hauptf.mapm.Text:=bufs;

  //panel fllen
  panelu.initp;
end;

procedure clrouta;
var
  r:integer;
begin
  for r:=0 to high(hauptf.map.outa)-1 do begin
    hauptf.map.outa[r].ch:=#0;
    hauptf.map.outa[r].map:='';
    hauptf.map.outa[r].mapstart:='';
  end;
end;

procedure clrdurchgang;
var
  r:integer;
begin
  for r:=0 to high(hauptf.map.durchgang)-1 do begin
    hauptf.map.durchgang[r]:=#0;
  end;
end;

//----------------------------------------------------------------
procedure setmap_info;
begin
  //startwert
  hauptf.map.startpos.x:=15.22;
  hauptf.map.startpos.y:=1.77;
  hauptf.map.startpos.z:=20.06;

  hauptf.map.startrot.x:=0;
  hauptf.map.startrot.y:=20;
  hauptf.map.startrot.z:=0;

  hauptf.map.h:=3;

  //durchgnge-chars
  clrdurchgang;
  hauptf.map.durchgang[0]:='i';

  //lese map, objekte und personen
  rdmap('Info',hauptf.map);

  //decken/boden-aufteilung adaptieren
  hauptf.map.txdeckewc:=hauptf.map.w/2;
  hauptf.map.txdeckedc:=hauptf.map.d/2;

  hauptf.map.txbodenwc:=hauptf.map.w/2;
  hauptf.map.txbodendc:=hauptf.map.d/2;


  //ausgnge setzen
  clrouta;
  hauptf.map.outa[0].ch:='D';
  hauptf.map.outa[0].map:='Flur';
  hauptf.map.outa[0].mapstart:='90';

  //springe startpos
  hauptf.sethome;
end;

//----------------------------------------------------------------
procedure setmap_flur;
begin
  hauptf.map.startpos.x:=73.5;
  hauptf.map.startpos.y:=1.77;
  hauptf.map.startpos.z:=9.5;

  hauptf.map.startrot.x:=0;
  hauptf.map.startrot.y:=0;
  hauptf.map.startrot.z:=0;

  hauptf.map.h:=7;

  //durchgnge-chars
  clrdurchgang;
  hauptf.map.durchgang[0]:='i';
  hauptf.map.durchgang[1]:='F';

  rdmap('Flur',hauptf.map);

  hauptf.map.txdeckewc:=hauptf.map.w/10;
  hauptf.map.txdeckedc:=1;//hauptf.mapz/4;

  hauptf.map.txbodenwc:=hauptf.map.w/2;
  hauptf.map.txbodendc:=hauptf.map.d/2;

  hauptf.map.txdeckez:=hauptf.flb.Items.indexof('txdeckez.jpg')+hauptf.pflb.Items.count;
  hauptf.map.txdeckezwc:=hauptf.map.w/4;
  hauptf.map.txdeckezdc:=hauptf.map.d/2;

  clrouta;
  hauptf.map.outa[0].ch:='d';
  hauptf.map.outa[0].map:='Info';
  hauptf.map.outa[0].mapstart:='90';

  hauptf.map.outa[1].ch:='D';
  hauptf.map.outa[1].map:='Mode';
  hauptf.map.outa[1].mapstart:='90';

  hauptf.sethome;
end;

//----------------------------------------------------------------
procedure setmap_mode;
begin
  hauptf.map.startpos.x:=53;
  hauptf.map.startpos.y:=1.77;
  hauptf.map.startpos.z:=37;

  hauptf.map.startrot.x:=0;
  hauptf.map.startrot.y:=0;
  hauptf.map.startrot.z:=0;

  hauptf.map.h:=3;

  //durchgnge-chars
  clrdurchgang;
  hauptf.map.durchgang[0]:='e';

  rdmap('Mode',hauptf.map);

  hauptf.map.txdeckewc:=hauptf.map.w/2;
  hauptf.map.txdeckedc:=hauptf.map.d/2;

  hauptf.map.txbodenwc:=hauptf.map.w/2;
  hauptf.map.txbodendc:=hauptf.map.d/2;

  clrouta;
  hauptf.map.outa[0].ch:='d';
  hauptf.map.outa[0].map:='Flur';
  hauptf.map.outa[0].mapstart:='91';

  hauptf.map.outa[1].ch:='u';
  hauptf.map.outa[1].map:='EDV';
  hauptf.map.outa[1].mapstart:='90';

  hauptf.sethome;
end;

//----------------------------------------------------------------
procedure setmap_edv;
begin
  hauptf.map.startpos.x:=8.72;
  hauptf.map.startpos.y:=1.77;
  hauptf.map.startpos.z:=10.97;

  hauptf.map.startrot.x:=0;
  hauptf.map.startrot.y:=540;
  hauptf.map.startrot.z:=0;

  hauptf.map.h:=2.8;
  clrdurchgang;

  rdmap('EDV',hauptf.map);

  hauptf.map.txdeckewc:=hauptf.map.w/3;
  hauptf.map.txdeckedc:=hauptf.map.d/3;

  hauptf.map.txbodenwc:=hauptf.map.w;
  hauptf.map.txbodendc:=hauptf.map.d;

  clrouta;
  hauptf.map.outa[0].ch:='D';
  hauptf.map.outa[0].map:='Mode';
  hauptf.map.outa[0].mapstart:='91';

  hauptf.sethome;
end;

//----------------------------------------------------------------
procedure setpersonquad(tx:gluint;x,y,z,w,h,d:single;var q:tquad);
begin
  q.pos.x:=x;q.pos.y:=y;q.pos.z:=z;
  q.dim.w:=w;q.dim.h:=h;q.dim.d:=d;
  //q.rot.x:=0;q.rot.y:=0;q.rot.z:=0;

  q.tex.wc:=1;
  q.tex.dc:=1;
  q.tex.o:=tx;q.tex.u:=tx;
  q.tex.l:=tx;q.tex.r:=tx;
  q.tex.v:=tx;q.tex.h:=tx;
end;

procedure setobjquad(tx:gluint;x,y,z,w,h,d:single;var q:tquad);
begin
  q.pos.x:=x;q.pos.y:=y;q.pos.z:=z;
  q.dim.w:=w;q.dim.h:=h;q.dim.d:=d;
  //q.rot.x:=0;q.rot.y:=0;q.rot.z:=0;

  q.tex.wc:=1;
  q.tex.dc:=1;
  q.tex.o:=tx;q.tex.u:=tx;
  q.tex.l:=tx;q.tex.r:=tx;
  q.tex.v:=tx;q.tex.h:=tx;
end;

function s2quad(ss:string;x,z,w,d:byte;var q:tquad):bool;

    function filter(s:string;ch:char;v:byte):byte;
    var
      c:byte;
    begin
      result:=1;

      //tx_ww_h4_ww_d11.jpg
      //vorbau weg -> _ww_d11.jpg
      s:=copy(s,9,length(s));

      //suche parameter
      c:=pos('_'+ch,s);
      if c=0 then exit;

      //parameter weg -> w_d11.jpg
      s:=copy(s,c+2,length(s));
      if length(s)=0 then begin
        beep;
        exit;
      end;

      //x-dimensional?
      if s[1]=ch then begin
        result:=v;
        exit;
      end;

      //anzahl extrahieren
      c:=1;while(c<length(s))and(s[c] in ['0'..'9'])do inc(c);

      try
        result:=strtoint(copy(s,1,c-1));
      except
        beep;
      end;
    end;

var
  fn,s:string;
  foundok:bool;
  r:integer;
  tx:gluint;
  y,h:single;
  ch:char;
begin
  result:=true;
  ch:=ss[1];

  if(ch>='0')and(ch<='9')then begin
    //person: bestimme tex-index
    s:='tx_'+ss+'.jpg';
    r:=hauptf.pflb.Items.indexof(s);
    if r=-1 then begin
      result:=false;
      exit;
    end;

    y:=1;h:=1;
    setpersonquad(r,x,y,z,w,h,d,q);
    //person2quad(ch,x,z,q)
  end
  else begin

    //eintrag holen
    foundok:=false;
    tx:=0;
    for r:=0 to hauptf.flb.Items.count-1 do begin
      s:=lowercase(hauptf.flb.Items[r]);

      //grossbuchstabe?
      if ch=uppercase(ch) then foundok:=copy(s,4,2)=lowercase(ch+ch)
                          else foundok:=copy(s,4,2)=lowercase(ch+'0');

      if foundok then begin
        tx:=r+hauptf.pflb.Items.count;
        fn:=hauptf.flb.Items[r];
        break;
      end;
    end;

    if not foundok then begin
      beep;
      exit;
    end;

    //hhe besimmen
    //tx_ww_h4.jpg
    s:=copy(s,7,2);
    y:=0;h:=hauptf.map.h;
    if      s='h0' then begin h:=0;y:=0.01;end
    else if s='h1' then h:=0.8
    else if s='h2' then begin h:=0.6;y:=0.8;end
    else if s='h3' then h:=2
    else if s='h4' then begin h:=0.8;y:=1.8;end

    else if s='h5' then  h:=hauptf.map.h-4

    else if s='h6' then begin h:=hauptf.map.h-4;y:=4;end

    else if s='h7' then h:=hauptf.map.h-2
    else if s='h8' then h:=hauptf.map.h-1
    else if s='h9' then h:=hauptf.map.h
    else begin
      beep;
    end;

    setobjquad(tx,x,y,z,w,h,d,q);

    //if fn='tx_rr_h9_w3_d3.jpg' then beep;

    //aufteilung textur breite
    //tx_ww_h4_ww_d11.jpg
    q.tex.wc:=filter(fn,'w',w);
    q.tex.dc:=filter(fn,'d',d);

    //textur andere seite?
    fn:=copy(fn,1,length(fn)-4);

    r:=hauptf.flb.items.indexof(fn+'_o.jpg');if r>-1 then q.tex.o:=r++hauptf.pflb.Items.count;
    r:=hauptf.flb.items.indexof(fn+'_r.jpg');if r>-1 then q.tex.r:=r+hauptf.pflb.Items.count;
    r:=hauptf.flb.items.indexof(fn+'_v.jpg');if r>-1 then q.tex.v:=r+hauptf.pflb.Items.count;
    r:=hauptf.flb.items.indexof(fn+'_h.jpg');if r>-1 then q.tex.h:=r+hauptf.pflb.Items.count;

  end;
end;

end.

