unit panelu;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs,DGLOpenGL, StdCtrls,
  easySDL,SDL,SDL_Image, ImgList, Grids, SortGrid, FileCtrl, ExtCtrls,
  hauptu;

const
  _dw=1;
  _dd=1;
  _pcolor=clwhite;

type
  tp=class(tpanel)
  end;

procedure initp;
procedure paintp(var collision:bool);
procedure chgmap(o:tout);

implementation

uses mapu;

procedure initp;
var
  cv:tcanvas;
  rr,x,z,r,c,d,w:integer;
  s:string;
  collision:bool;
  ok:bool;
begin
  w:=trunc(hauptf.map.w*_dw)+10;
  d:=trunc(hauptf.map.d*_dd)+10;

  hauptf.p.clientWidth:=w;
  hauptf.p.clientheight:=d;

  //tp(hauptf.p).canvas.brush.Color:=clblack;
  hauptf.pbmp.Width:=w;
  hauptf.pbmp.height:=d;

  //cv:=tp(hauptf.p).canvas;
  cv:=hauptf.pbmp.canvas;

  cv.Brush.color:=_pcolor;
  cv.Rectangle(0,0,w,d);

  for r:=0 to hauptf.mapm.lines.count-1 do begin
    z:=r*_dd+5;
    s:=hauptf.mapm.Lines[r];
    for c:=1 to length(s) do begin
      if s[c]=' ' then continue;
      //if s[c]='i' then continue;
      if s[c] in ['0'..'9'] then continue;

      //durch bestimmte zeichen kann durchgegangen werden, z.B. Vorhang
      ok:=false;
      for rr:=0 to high(hauptf.map.durchgang)-1 do begin
        if s[c]= hauptf.map.durchgang[rr] then begin
          ok:=true;
          break;
        end;
      end;
      if ok then continue;

      x:=(c-1)*_dw+5;

      cv.Pixels[x,z]:=clblack;
      {
      cv.Pixels[x+1,z]:=clblack;
      cv.Pixels[x,z+1]:=clblack;
      cv.Pixels[x+1,z+1]:=clblack;
      }
    end;
  end;

  hauptf.ppbmp.width:=w;
  hauptf.ppbmp.height:=d;

  paintp(collision);
end;

procedure paintp(var collision:bool);
var
  r,x,z,w,d:integer;
  s:string;
begin
  collision:=false;
  if not hauptf.p.Visible then exit;

  //dimensionen
  w:=hauptf.pbmp.Width;
  d:=hauptf.pbmp.height;

  //mapbackground
  bitblt(
    hauptf.ppbmp.canvas.Handle,0,0,w,d,
    hauptf.pbmp.canvas.handle,0,0,
    srccopy
  );


  //aktuelle position
  x:=trunc(hauptf.px)*2*_dw+5;
  z:=trunc(hauptf.pz)*2*_dd+5;
  if(x>1)and(x<w-2)and(z>1)and(z<d-2)then begin

    //kollision?
    collision:=(tcolor(hauptf.ppbmp.canvas.pixels[x,z])<>_pcolor);

    if not collision then collision:=(tcolor(hauptf.ppbmp.canvas.pixels[x,z+1])<>_pcolor);
    //if not collision then collision:=(tcolor(hauptf.ppbmp.canvas.pixels[x,z+2])<>_pcolor);
    if not collision then collision:=(tcolor(hauptf.ppbmp.canvas.pixels[x+1,z])<>_pcolor);
    //if not collision then collision:=(tcolor(hauptf.ppbmp.canvas.pixels[x+2,z])<>_pcolor);
    if not collision then collision:=(tcolor(hauptf.ppbmp.canvas.pixels[x+1,z+1])<>_pcolor);
    //if not collision then collision:=(tcolor(hauptf.ppbmp.canvas.pixels[x+2,z+2])<>_pcolor);


    if not collision then begin
      {
      hauptf.ppbmp.canvas.pixels[x-1,z-1]:=clred;
      hauptf.ppbmp.canvas.pixels[x-1,z]:=clred;
      hauptf.ppbmp.canvas.pixels[x-1,z+1]:=clred;

      hauptf.ppbmp.canvas.pixels[x,z-1]:=clred;
      hauptf.ppbmp.canvas.pixels[x,z]:=clred;
      hauptf.ppbmp.canvas.pixels[x,z+1]:=clred;

      hauptf.ppbmp.canvas.pixels[x+1,z-1]:=clred;
      hauptf.ppbmp.canvas.pixels[x+1,z]:=clred;
      hauptf.ppbmp.canvas.pixels[x+1,z+1]:=clred;
      }

      hauptf.ppbmp.canvas.pixels[x,z]:=hauptf.ccolor;

      {
      hauptf.ppbmp.canvas.pixels[x+1,z]:=clred;
      hauptf.ppbmp.canvas.pixels[x,z+1]:=clred;
      hauptf.ppbmp.canvas.pixels[x+1,z+1]:=clred;
      }
    end
    else begin
      //ausgang erwischt?

      x:=trunc(hauptf.px)*2;
      z:=trunc(hauptf.pz)*2;
      if
        (x>-1)and(x<trunc(hauptf.map.w))and
        (z>-1)and(z<trunc(hauptf.map.d))
      then begin
        s:=hauptf.mapm.Lines[z];
        s:=s[x+1];

        for r:=0 to high(hauptf.map.outa)-1 do begin
          if s=hauptf.map.outa[r].ch then begin
            collision:=false;
            chgmap(hauptf.map.outa[r]);
            exit;
          end;
        end;
      end;
    end;
  end;

  if hauptf.ccolor=clred then hauptf.ccolor:=clyellow
                         else hauptf.ccolor:=clred;
  try
    bitblt(
      tp(hauptf.p).canvas.Handle,0,0,w,d,
      hauptf.ppbmp.canvas.handle,0,0,
      srccopy
    );
  except
  end;

  //tp(hauptf.p).canvas.pixels[20,20]:=clyellow;

end;

procedure chgmap(o:tout);
var
  r,c:integer;
  s,mapstart:string;
  rx,ry,rz:single;
begin
  //positionswerte merken
  mapstart:=o.mapstart;
  rx:=hauptf.rotx;
  ry:=hauptf.roty;
  rz:=hauptf.rotz;


  //map laden
  if      o.map='Info' then setmap_info
  else if o.map='Flur' then setmap_flur
  else if o.map='Mode' then setmap_mode
  else if o.map='EDV' then setmap_edv;

  //finde startposition
  for r:=0 to hauptf.mapm.Lines.count-1 do begin
    s:=hauptf.mapm.Lines[r];
    c:=pos(mapstart,s);
    if c>0 then begin
      hauptf.px:=(c+1)/2;
      hauptf.pz:=r/2;

      //rotation anpassen
      hauptf.rotx:=rx;
      hauptf.roty:=ry;
      hauptf.rotz:=rz;

      exit;
    end;
  end;
end;

end.
